Bug 481388 - svc_req ABI incompatibility between glibc and libtirpc
svc_req ABI incompatibility between glibc and libtirpc
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: libtirpc (Show other bugs)
10
All Linux
low Severity medium
: ---
: ---
Assigned To: Steve Dickson
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-01-23 17:44 EST by Chuck Lever
Modified: 2009-02-04 21:16 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-02-04 21:16:32 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to correct ordering of fields in libtirpc's svc_req structure (3.43 KB, patch)
2009-01-23 17:44 EST, Chuck Lever
no flags Details | Diff

  None (edit)
Description Chuck Lever 2009-01-23 17:44:32 EST
Created attachment 329888 [details]
Patch to correct ordering of fields in libtirpc's svc_req structure

Description of problem:
The svc_req struct is returned from a number of public RPC functions.  The field order in the libtirpc version is slightly different than the field order in the legacy glibc version.  This causes compatibility problems in large RPC-related software products that may be transitioning from legacy to tirpc.

Version-Release number of selected component (if applicable):
All versions of libtirpc to date.

How reproducible:
Always

Steps to Reproduce:
1. compare the position of the rq_xprt field in /usr/include/rpc/svc.h's svc_req to /usr/include/tirpc/rpc/svc.h's svc_req
2.
3.
  
Actual results:
TI-RPC's svc_req contains the extra fields rq_clntname and rq_svcname which makes the offset to rq_xprt incorrect.

Expected results:
The offset of the rq_xprt field should be the same in both definitions to guarantee ABI compatibility

Additional info:

This is a problem when an RPC application is built using libtirpc for client operations, but the server components still call and link with glibc's RPC functions.
Comment 1 Steve Dickson 2009-01-28 10:30:48 EST
Fixed in libtirpc-0.1.10-3.fc11
Fixed in libtirpc-0.1.10-2.fc10
Comment 2 Fedora Update System 2009-01-29 18:09:26 EST
libtirpc-0.1.10-2.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update libtirpc'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-1171
Comment 3 Fedora Update System 2009-02-04 21:16:29 EST
libtirpc-0.1.10-2.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.